//******************************************************************************
// (C) 2006 by Libor Besenyi
// LiborBes@devnet.sk
//******************************************************************************
unit IndexOfManager;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, StdCtrls, ComCtrls, ExtCtrls, Psock, NMHttp,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  HTTPApp, HTTPProd, URLMon, ShellApi;

const
  MAX = 30000;                                  // Maximalny pocet adr./sub. v adresari

type
  //----------------------------------------------------------------------------
  TZasobnik = record
    Level: Integer;
    Name: String[40];                           // POZOR na staticku velkost
    IsFile: Boolean;                            // Jedna sa o list stromu?
  end;

  //----------------------------------------------------------------------------
  TStrom = class
  private
    FRoot: String;                              // Stromovy "wraper" - nulta uroven
    FZasobnik: Array[0..(MAX - 1)] of TZasobnik;     // Reprezentacia samotnejho zasobnika
    FCount: Integer;                            // Aktualny pocet zaznamov
    FLevel: Integer;                            // TZasobnik.Level
    FName: String;                              // TZasobnik.Name
    FIsFile: Boolean;                           // TZasobnik.IsFile
    FToken: Integer;                            // Token pohybu po zasobniku

    function ZasobnikNull: TZasobnik;           // Vrati nulovy zaznam
  public
    property Root: String read FRoot write FRoot;
    property Count: Integer read FCount write FCount;
    property Level: Integer read FLevel write FLevel default 1;
    property Name: String read FName write FName;
    property IsFile: Boolean read FIsFile write FIsFile default FALSE;
    property Token: Integer read FToken write FToken;

    function Rec: TZasobnik;                    // Vrati konkretny zaznam (podla tokenu)
    procedure Add;                              // Prida zaznam na koniec zasobnika (podla property)

    constructor Create;
  end;

  //----------------------------------------------------------------------------
  TForm1 = class(TForm)
    PanelTop: TPanel;
    LabelURL: TLabel;
    EditURL: TEdit;
    Progress: TProgressBar;
    ButtonAnalyzuj: TButton;
    HTTP: TIdHTTP;
    ListBox: TListBox;
    ButtonMulti: TButton;
    ButtonAdresar: TButton;
    LabelAdresare: TLabel;
    LabelSubory: TLabel;
    procedure ButtonAnalyzujClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxDblClick(Sender: TObject);
    procedure ButtonMultiClick(Sender: TObject);
    procedure ButtonAdresarClick(Sender: TObject);
    procedure EditURLKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  end;

var
  Form1: TForm1;
  Strom: TStrom;

implementation

{$R *.dfm}

//******************************************************************************
// TStrom objekt
//******************************************************************************

//******************************************************************************
Constructor TStrom.Create;
begin
  FRoot   := '';
  FCount  := 0;
  FLevel  := 1;
  FName   := '';
  FIsFile := False;
  FToken  := -1;
end;

//******************************************************************************
function TStrom.ZasobnikNull: TZasobnik;
var
   Pom: TZasobnik;
begin
  Pom.Level  := 1;
  Pom.Name   := '';
  Pom.IsFile := False;
end;

//******************************************************************************
function TStrom.Rec: TZasobnik;
begin
  if (FToken > -1) then
    Result := FZasobnik[FToken]
  else
    Result := ZasobnikNull;
end;

//******************************************************************************
procedure TStrom.Add;
var OK: Boolean;
{!}        I: Integer; t: TextFile;
begin
  OK := True;
  if Count < MAX then begin
    if (Level >= 0) and (((Count > 0) and (FZasobnik[Count].Level <= Level)) or (Count = 0)) then
      FZasobnik[Count].Level := Level
    else
      OK := False;

    if Name <> '' then
      FZasobnik[Count].Name := Name
    else
      OK := False;

    FZasobnik[Count].IsFile := IsFile;
  end else
    OK := False;

  If OK then
    Inc(FCount);

{
  AssignFile(t,'C:\A.A');
  Rewrite(t);
  for I:=0 to Pred(Count) do
    writeln(t,IntToStr(I+1),#32,IntToStr(FZasobnik[I].Level),#32,FZasobnik[I].Name,#32,Byte(FZasobnik[I].IsFile));
  CloseFile(T);
{}
end;

//******************************************************************************
// Pomocne fcie
//******************************************************************************

//******************************************************************************
function DownloadFile(Z, C: string): Boolean;
begin
  try // EXCEPT
    Result := UrlDownloadToFile(nil, PChar(Z), PChar(C), 0, nil) = 0;
  except
    Result := False;
  end; // EXCEPT
end;

//******************************************************************************
function Znakov(Znak: Char; Retazec: String): Integer;
var
   Index: Integer;
begin
  Index := 0;
  While (Pos(Znak, Retazec) > 0) do
  begin
    Delete(Retazec, Pos(Znak, Retazec), 1);
    Inc(Index);
  end; // WHILE
  Result := Index;
end;

//******************************************************************************
// JADRO
//******************************************************************************

//******************************************************************************
procedure TForm1.ButtonAnalyzujClick(Sender: TObject);
var
    Doc, S: String;
begin
  // Vytiahne HTML dokument
  try // finally
    Doc := HTTP.Get(EditURL.Text);
    ListBox.Items.Clear;

    // Overime, ci sa jedna o "index of"
    S := Doc;
    if (Pos('TITLE', UpperCase(S)) > 0) then
    begin
      Delete(S, 1, Pos('TITLE', UpperCase(S)) + 5);
      If (Pos('INDEX OF', UpperCase(S)) < Pos('TITLE', UpperCase(S))) and
         (Pos('INDEX OF', UpperCase(S)) > 0) then
      begin
        Delete(Doc, 1, Pos('PARENT DIR', UpperCase(Doc))); // Odrezeme zaciatok
        ListBox.Items.Add('..');

        // Rozparsuje data
        while (Pos('<A HREF', UpperCase(Doc)) > 0) do
        begin
          Delete(Doc, 1, Pos('<A HREF', UpperCase(Doc)) + Length('<A HREF'));

          While not (UpCase(Doc[1]) in ['A'..'Z', '0'..'9']) do // Odstrani vsetky znaky ktore nie su v abecede
            Delete(Doc, 1, 1);

          S := '';
          While (Doc[1] <> '>') and (Doc[1] <> '"') do // Vytiahne nazov
          begin
            S := S + Doc[1];
            Delete(Doc, 1, 1);
          end; // WHILE

          ListBox.Items.Add(S);
        end; // WHILE
      end; // IF
      // else nenasiel sa TITLE INDEX OF resp, INDEX OF sa nachadza mimo <TITLE>..</TITLE>
    end; // IF
    // else neexistuje TITLE stranky - urcite sa nejedna o Apachom spristupnene subory
  except
    ShowMessage('Vyskytla sa neocakavana chyba ' + #13#10 + EditURL.Text);
  end; // finally
end;

//******************************************************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
end;

//******************************************************************************
procedure TForm1.ListBoxDblClick(Sender: TObject);
var
   URL: String;
begin
  URL := EditUrl.Text;
  If URL[Length(URL)] <> '/' then
    URL := URL + '/';

  If ListBox.Items[ListBox.ItemIndex] = '..' then // O adresar nizsie?
  begin
    repeat
      Delete(URL, Length(URL), 1);
    until (URL[Length(URL)] = '/');
    EditURL.Text := URL;
    ButtonAnalyzujClick(Sender)
  end else // IF
  if Pos('/', ListBox.Items[ListBox.ItemIndex]) > 0 then // O adresar vyssie?
  begin
    URL := URL + ListBox.Items[ListBox.ItemIndex];
    EditURL.Text := URL;
    ButtonAnalyzujClick(Sender);
  end // IF
  else // Inac stiahni subor
  begin
    Try // EXCEPT
      ForceDirectories('C:\DOWNLOAD')
    except
      ShowMessage('Problem pri vytvarani cesty');
    end; // EXCEPT

    if not DownloadFile(URL + ListBox.Items[ListBox.ItemIndex], 'c:\download\' + ListBox.Items[ListBox.ItemIndex]) then
      ShowMessage('Problem pri stahovani suboru');
  end; // ELSE
end;

//******************************************************************************
procedure TForm1.ButtonMultiClick(Sender: TObject);
var
   URL: String;
   Index: Integer;
begin
  URL := EditUrl.Text;
  If URL[Length(URL)] <> '/' then
    URL := URL + '/';

  Progress.Max := ListBox.SelCount;
  Progress.Position := 0;
  for Index := 0 to Pred(ListBox.Items.Count) do
    if (ListBox.Selected[Index]) and
       (ListBox.Items[Index] <> '..') and
       (Pos('/', ListBox.Items[Index]) = 0) then
    begin
      Try // EXCEPT
        ForceDirectories('C:\DOWNLOAD')
      except
        ShowMessage('Problem pri vytvarani cesty');
      end; // EXCEPT

      if not DownloadFile(URL + ListBox.Items[Index], 'c:\download\' + ListBox.Items[Index]) then
        ShowMessage('Problem pri stahovani suboru');

      Progress.Position := Progress.Position + 1;
    end; // IF
    Progress.Position := 0;
end;

//******************************************************************************
procedure TForm1.ButtonAdresarClick(Sender: TObject);

  //----------------------------------------------------------------------------
  procedure Prechadzaj(Stupen: Integer; URL: String);
  var
     Index: Integer;
  begin
    // Nacita stromovu strukturu
    EditURL.Text := URL;
    ButtonAnalyzujClick(Sender);
    // Prechadza vyparsovane zaznamy v ListBoxe a trieska ich do zoznamu
    for Index := 1 to Pred(ListBox.Items.Count) do
    begin
      Strom.Level := Stupen;
      Strom.Name := ListBox.Items[Index];
      If Pos('/', ListBox.Items[Index]) > 0 then // Jedna sa o adresar
      begin
        Strom.IsFile := False;
        LabelAdresare.Caption := IntToStr(StrToInt(LabelAdresare.Caption) + 1)
      end else // IF
      begin
        Strom.IsFile := True;
        LabelSubory.Caption := IntToStr(StrToInt(LabelSubory.Caption) + 1);
      end; // ELSE
      // Pred zapisom predsa radsej "podozrive" veci nepchat do zasobnika
      if (Znakov('/', Strom.Name) <= 1) then
        Strom.Add;
    end; // FOR

    Index := Pred(Strom.Count);
    Strom.Token := Index;
    if (Strom.Rec.Level = Stupen) then // Pre pripad, ze adresar neobsahuje nic, treba takto osetrit
      repeat
        if Pos('/', Strom.Rec.Name) > 0 then
          Prechadzaj(Index+1, URL + Strom.Rec.Name); // Rekurzivne vojde do dalsej vetvy

        Dec(Index);
        Strom.Token := Index;
      until (Strom.Rec.Level <> Stupen) or (Index < 0);
  end;

var
   Sub, Pom, URL: String;
   Index, Q: Integer;
begin
  if (ListBox.SelCount = 1) and (Pos('/', ListBox.Items[ListBox.ItemIndex]) > 0) and
     (ListBox.Items[ListBox.ItemIndex] <> '..') then
  begin
    ShowMessage('Analyza stromovej struktury moze chvilku trvat'+#13#10+
                'prosim o strpenie, nez sa zahaji samotne kopirovanie');

    Strom := TStrom.Create;
    try // FINALLY
      URL := EditUrl.Text;
      If URL[Length(URL)] <> '/' then
        URL := URL + '/';

      // Stromova struktura podadresarov
      Strom.Root := URL + ListBox.Items[ListBox.ItemIndex];
      LabelAdresare.Caption := '0';
      LabelSubory.Caption := '0';
      Prechadzaj(0, URL + ListBox.Items[ListBox.ItemIndex]);

      // Nacita stromovu strukturu zo zaciatku
      Progress.Max := StrToInt(LabelSubory.Caption);
      Progress.Position := 0;
      EditURL.Text := Strom.Root;
      ButtonAnalyzujClick(Sender);
      // Spatne hladanie suborov
      for Index := Pred(Strom.Count) downto 0 do
      begin
        Strom.Token := Index;
//        ShowMessage(Strom.Rec.Name);
        if Strom.Rec.IsFile then // Ak sa jedna o subor, treba vyskladat jeho URL
        begin
          Pom := Strom.Rec.Name;
          Q := Strom.Rec.Level;
          while (Q <> 0) do
          begin
            Strom.Token := Q - 1; // Presunieme sa na jeho potomka
            Pom := Strom.Rec.Name + Pom;
            Q := Strom.Rec.Level;
          end; // WHILE
          URL := Strom.Root + Pom;
          // Z pom urobime cestu na ulozenie
          Pom := URL;
          While (Pom[Length(Pom)] <> '/') do // Zbavime sa nazvu suboru
            Delete(Pom, Length(Pom), 1);
          While (Pos('/', Pom) > 0) do // Nahradime lomitka / za \
            Pom[Pos('/',Pom)] := '\';
          Delete(Pom, 1, Pos('WWW', UpperCase(Pom))+3); // Odstranime nazov webu
          Delete(Pom, 1, Pos('\', Pom)+1);
          Pom := 'C:\DOWNLOAD\' + Pom;
          //ShowMessage(Pom + Strom.Rec.Name);
          Try // EXCEPT
            ForceDirectories(Pom) // Vytvori cestu, ak neexistuje
          except
            ShowMessage('Problem pri vytvarani cesty');
          end; // EXCEPT
          // Vytiahnutie nazvu suboru z URL
          Sub := URL;
          While (Pos('/', Sub) > 0) do
            Delete(Sub, 1, Pos('/', Pom) + 1);
          //ShowMessage(Sub);
          // Samotne ulozenie suboru
          if not DownloadFile(URL, Pom + Sub) then
            ShowMessage('Problem pri stahovani suboru '+ URL);
          Progress.Position := Progress.Position + 1;
        end; // IF
      end; // FOR
      Progress.Position := 0;
    finally
      Strom.Free;
    end; // FINALLY
  end else
    ShowMessage('Nastal jeden z problemov'+#13#10+
                '1. Multiselekt kopirovania adresarov tato verzia nepodporuje'+#13#10+
                '2. Pokusate sa "kopirovat" vstup o uroven nizsie alebo subor'
               );
end;

//******************************************************************************
procedure TForm1.EditURLKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = 13 then
    ButtonAnalyzujClick(Sender);
end;

end.
